<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <ui:decorate template="_template.xhtml">
            <ui:param name="pageName" value="AIPO"/>
            <ui:param name="controllerName" value="#{appliesToAipoManager}"/>
            <ui:param name="tabId" value="menuTabs"/>
            <ui:param name="linkEntityFilterDivTitle"
                      value="#{messages['net.ihe.gazelle.assertion-manager.AiposFilter']}"/>
            <ui:define name="linkEntityFilterDiv">
                <h:form id="filterform" styleClass="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="domain"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Domain']}</ui:define>
                        <h:selectOneMenu id="domain" styleClass="form-control gzl-select-text"
                                         value="#{appliesToAipoManager.selectedDomain}">
                            <s:selectItems var="domainAvailable"
                                           label="#{domainAvailable}"
                                           value="#{appliesToAipoManager.getDomainsAvailable()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="filterform,aiposForm,description,idSchemesForm"/>
                        </h:selectOneMenu>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="ip"/>
                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.IntegrationProfile']}
                        </ui:define>
                        <h:selectOneMenu id="ip" styleClass="form-control gzl-select-text"
                                         value="#{appliesToAipoManager.selectedIntegrationProfileName}">
                            <s:selectItems var="iP" label="#{iP}"
                                           value="#{appliesToAipoManager.getIntegrationProfilesNames()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="filterform,aiposForm,description,idSchemesForm"/>
                        </h:selectOneMenu>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="actors"/>
                        <ui:define name="label">#{messages['gazelle.simulator.Actor']}</ui:define>
                        <h:selectOneMenu id="actors" styleClass="form-control gzl-select-text"
                                         value="#{appliesToAipoManager.selectedActor}">
                            <s:selectItems var="filteredActor" label="#{filteredActor}"
                                           value="#{appliesToAipoManager.getActors()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="filterform,aiposForm,description,idSchemesForm"/>
                        </h:selectOneMenu>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                        <ui:param name="id" value="ipo"/>
                        <ui:define name="label">#{messages['gazelle.simulator.Option']}</ui:define>
                        <h:selectOneMenu id="ipo" styleClass="form-control gzl-select-text"
                                         value="#{appliesToAipoManager.selectedIntegrationProfileOption}">
                            <s:selectItems var="ipo" label="#{ipo}"
                                           value="#{appliesToAipoManager.getIntegrationProfileOptions()}"
                                           noSelectionLabel="#{messages['gazelle.common.button.ShowAll']}"/>
                            <a4j:ajax event="change" execute="@this"
                                      render="filterform,aiposForm,description,idSchemesForm"/>
                        </h:selectOneMenu>
                    </s:decorate>
                </h:form>
            </ui:define>
            <ui:define name="idSchemeFilterPanel">
                <ui:include src="_assertionsFilters.xhtml">
                    <ui:param name="filterParam" value="#{appliesToAipoManager.filter}"/>
                    <ui:param name="idSchemeIdToRefresh" value="idSchemesForm,menuTabs"/>
                </ui:include>
            </ui:define>
            <ui:define name="linkingEntityFold">
                <div class="row">
                    <div class="col-md-4">
                        <h:form id="aiposForm">
                            <s:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    <h:outputText
                                            value="#{appliesToAipoManager.aipos.size()} #{messages['net.ihe.gazelle.assertion-manager.FilteredAipos']}"/>
                                </ui:define>
                                <rich:dataTable rows="20" id="idTests" var="currentAipo"
                                                value="#{appliesToAipoManager.aipos}" render="idTestsDs">
                                    <g:column sortBy="#{'actor'}" style="word-break: break-all;">
                                        <ui:define name="header">#{messages['gazelle.simulator.Actor']}</ui:define>
                                        <h:outputText value="#{currentAipo.actor}"
                                                      style="#{appliesToAipoManager.getSelectedAipo().getId() == currentAipo.getId() ? 'font-weight:bold;' : ''}"/>
                                    </g:column>
                                    <g:column sortBy="#{'integrationProfile'}" style="word-break: break-all;">
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.IntegrationProfile']}
                                        </ui:define>
                                        <h:outputText value="#{currentAipo.integrationProfile}"
                                                      style="#{appliesToAipoManager.getSelectedAipo().getId() == currentAipo.getId() ? 'font-weight:bold;' : ''}"/>
                                    </g:column>
                                    <g:column sortBy="#{'integrationProfileOption'}" style="word-break: break-all;">
                                        <ui:define name="header">#{messages['gazelle.simulator.Option']}</ui:define>
                                        <h:outputText value="#{currentAipo.integrationProfileOption}"
                                                      style="#{appliesToAipoManager.getSelectedAipo().getId() == currentAipo.getId() ? 'font-weight:bold;' : ''}"/>
                                    </g:column>
                                    <g:column>
                                        <ui:define name="header">
                                            #{messages['net.ihe.gazelle.assertion-manager.Covered']}
                                        </ui:define>
                                        <h:outputText
                                                value="#{appliesToAipoManager.isAipoCovered(currentAipo.id)}"/>
                                    </g:column>
                                    <g:column>
                                        <a4j:commandLink
                                                value="#{messages['net.ihe.gazelle.assertion-manager.Select']}"
                                                immdediate="true"
                                                actionListener="#{appliesToAipoManager.setSelectedAipo(currentAipo)}"
                                                render="description,idSchemesForm,aiposForm,ruleCoverage"/>
                                    </g:column>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="idTestsDs"/>
                                            <ui:param name="dataTableId" value="idTests"/>
                                            <ui:param name="hideRowsSelect" value="true"/>
                                            <ui:param name="maxPages" value="5"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </s:decorate>
                        </h:form>
                    </div>
                    <div class="col-md-3">
                        <h:form id="description">
                            <h:panelGroup rendered="#{appliesToAipoManager.isAipoSelected()}">
                                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                    <ui:define name="panel_title">
                                        <h:outputText
                                                value="#{messages['net.ihe.gazelle.assertion-manager.DescriptionOf']} #{appliesToAipoManager.getSelectedAipo()} "/>
                                    </ui:define>
                                    <h:outputText value="#{appliesToAipoManager.getSelectedAipo().getDescription()}"/>
                                </ui:decorate>

                                <ui:decorate template="/layout/panels/_panel_title.xhtml">
                                    <ui:define name="panel_title">#{messages['net.ihe.gazelle.assertion-manager.Aipo']}
                                        (#{appliesToAipoManager.getSelectedAipo()})
                                        #{messages['net.ihe.gazelle.assertion-manager.IsLinkedToThoseAssertions']}
                                    </ui:define>
                                    <rich:dataTable rows="20" id="ruleCoverage"
                                                    var="assertionCoverage"
                                                    rendered="#{appliesToAipoManager.isAipoSelected()}"
                                                    value="#{appliesToAipoManager.assertionsOfSelectedAipo()}">
                                        <g:column id="action">
                                            <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                               rendered="#{appliesToAipoManager.isSelectedAipoLinkedTo(assertionCoverage.assertion.id)}"
                                                               actionListener="#{appliesToAipoManager.unlinkSelectedAipoFrom(assertionCoverage.assertion.id)}"
                                                               immdediate="true"
                                                               value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                               render="action,aiposForm,description,idSchemesForm"/>
                                        </g:column>
                                        <g:column
                                                sortBy="#{assertionCoverage.assertion.target.idScheme}"
                                                sortOrder="ascending">
                                            <ui:define name="header">
                                                #{messages['net.ihe.gazelle.assertion-manager.SelectIdScheme']}
                                            </ui:define>
                                            <a4j:commandLink immdediate="true"
                                                             value="#{assertionCoverage.assertion.target.idScheme}"
                                                             actionListener="#{appliesToAipoManager.setSelectedIdScheme(assertionCoverage.assertion.target.idScheme)}"
                                                             render="idSchemesForm,description,filterform"/>
                                        </g:column>
                                        <g:column sortBy="#{assertionCoverage.assertion.assertionId}"
                                                  sortOrder="ascending">
                                            <ui:define name="header">
                                                #{messages['net.ihe.gazelle.assertion-manager.AssertionId']}
                                            </ui:define>
                                            <h:outputLink id="linkAssertion" target="_assertion"
                                                          title="#{messages['net.ihe.gazelle.assertion-manager.ViewAssertion']}"
                                                          value="#{request.contextPath}/assertions/show.seam">
                                                <f:param name="id" value="#{assertionCoverage.assertion.id}"/>
                                                <h:outputText
                                                        value="#{assertionCoverage.assertion.assertionId}"/>
                                            </h:outputLink>
                                        </g:column>
                                    </rich:dataTable>
                                </ui:decorate>
                            </h:panelGroup>
                        </h:form>
                    </div>
                    <div class="col-md-5">
                        <h:form id="idSchemesForm">
                            <s:decorate template="/layout/panels/_panel_title.xhtml">
                                <ui:define name="panel_title">
                                    Assertions
                                </ui:define>
                                <ui:include src="../_linkAll.xhtml">
                                    <ui:param name="manager" value="#{appliesToAipoManager}"/>
                                </ui:include>
                                <rich:dataTable rows="20" id="idScheme" var="assertion"
                                                value="#{appliesToAipoManager.assertions}" render="idSchemeDs">
                                    <g:column id="action"
                                              rendered="#{appliesToAipoManager.isAipoSelected()}">
                                        <a4j:commandButton styleClass="btn-sm gzl-btn-green"
                                                           disabled="#{!appliesToAipoManager.isAipoSelected()}"
                                                           rendered="#{not appliesToAipoManager.isSelectedAipoLinkedTo(assertion.id) }"
                                                           actionListener="#{appliesToAipoManager.linkSelectedAipoTo(assertion.id)}"
                                                           immdediate="true"
                                                           value="#{messages['net.ihe.gazelle.assertion-manager.LinkTo']}"
                                                           render="idSchemesForm,aiposForm,description"/>
                                        <a4j:commandButton styleClass="btn-sm gzl-btn-red"
                                                           disabled="#{!appliesToAipoManager.isAipoSelected()}"
                                                           rendered="#{appliesToAipoManager.isSelectedAipoLinkedTo(assertion.id)}"
                                                           actionListener="#{appliesToAipoManager.unlinkSelectedAipoFrom(assertion.id)}"
                                                           immdediate="true"
                                                           value="#{messages['net.ihe.gazelle.assertion-manager.Unlink']}"
                                                           render="idSchemesForm,aiposForm,description"/>
                                    </g:column>
                                    <ui:include src="_applyAssertionsTable.xhtml">
                                        <ui:param name="assertionParam" value="#{assertion}"/>
                                    </ui:include>
                                    <f:facet name="footer">
                                        <ui:include src="/util/datatableFooter.xhtml">
                                            <ui:param name="dataScrollerId" value="idSchemeDs"/>
                                            <ui:param name="dataTableId" value="idScheme"/>
                                            <ui:param name="hideRowsSelect" value="true"/>
                                            <ui:param name="maxPages" value="5"/>
                                        </ui:include>
                                    </f:facet>
                                </rich:dataTable>
                            </s:decorate>
                        </h:form>
                        <ui:include src="../_linkAllPopup.xhtml">
                            <ui:param name="manager" value="#{appliesToAipoManager}"/>
                            <ui:param name="formToRender" value="aiposForm"/>
                        </ui:include>
                    </div>
                </div>
            </ui:define>
        </ui:decorate>
    </ui:define>
</ui:composition>